#include "camera.h"

namespace eda {

// typedef int(*img_Callback)(char *img_buff, int img_len);

class Camera_0234: public Camera{

public:
    Camera_0234();

    ~Camera_0234();

    /**
     * @brief 初始化摄像头，默认CMOS启动处于Hardware trigger mode
     * 
     * @return int 
     */
    int open(int mode, int width, int height);
    /**
     * @brief 关闭摄像头
     * 
     * @return int 
     */
    int close();
    
    /**
     * @brief 设置曝光时间
     * 
     * @param exp_value 取值范围1~1500，exp_value*6.8转换为us单位
     * @return int 
     */
    int set_exposure(int exp_value);
    /**
     * @brief 获取曝光时间
     * 
     * @param exp_value 取值范围1~1500，exp_value*6.8转换为us单位
     * @return int 
     */
    int get_exposure(int *exp_value);

    /**
     * @brief 设置增益
     * 
     * @param gain_value 取值范围 0~64
     * @return int 
     */
    int set_gain(int gain_value);
    /**
     * @brief 获取增益
     * 
     * @param gain_value 取值范围 0~64
     * @return int 
     */
    int get_gain(int *gain_value);

    /**
     * @brief 注册回调函数，获取图像数据
     * 
     * @param callback 
     * @return int 
     */
    int callback_image_ready(img_Callback callback);

    CameraName name();

    int call_trigger(){};
};

}